﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Infragistics.Web.UI.GridControls;

public partial class _Default : System.Web.UI.Page
{
    DataSet dsSource = new DataSet();
    DataTable dtLevel0 = null;
    DataTable dtLevel1 = null;

    protected void Page_Load(object sender, EventArgs e)
    {
        
        WebHierarchicalDataGrid1.DataSource = CreateData();
        WebHierarchicalDataGrid1.DataBind();
    }

    private DataSet CreateData()
    {
        dtLevel0 = Level0();
        dtLevel1 = Level1();

        dtLevel0.TableName = "Level0";
        dtLevel1.TableName = "Level1";


        dsSource.Tables.Add(dtLevel0);
       dsSource.Tables.Add(dtLevel1);

     


        return dsSource;
    }



    private DataTable Level1()
    {
        int numberOfRecords = 5;
        DataTable dtData = new DataTable();

        dtData.Columns.Add("Column_11", Type.GetType("System.String"));
        dtData.Columns.Add("Column_2", Type.GetType("System.String"));
        dtData.Columns.Add("Column_3", Type.GetType("System.String"));

        dtData.PrimaryKey = new DataColumn[] { dtData.Columns["Column_11"] };
        for (int i = 1; i < numberOfRecords; i++)
        {
            DataRow dr = dtData.NewRow();
            dr[0] = i.ToString();
            dr[1] = "child1 text";
            dr[2] = "Child:" + i.ToString();
            dtData.Rows.Add(dr);
        }
        return dtData;
    }

    private DataTable Level0()
    {
        int numberOfRecords = 10;
        DataTable dtData = new DataTable();

        dtData.Columns.Add("Column_10", Type.GetType("System.String"));
        dtData.Columns.Add("Column_2", Type.GetType("System.String"));
        dtData.Columns.Add("Column_3", Type.GetType("System.String"));
        dtData.PrimaryKey = new DataColumn[] { dtData.Columns["Column_10"] };
        for (int i = 1; i < numberOfRecords; i++)
        {
            DataRow dr = dtData.NewRow();
            dr[0] = i.ToString();
            dr[1] = "Parent text";
            dr[2] = "parent:" + i.ToString();
            dtData.Rows.Add(dr);
        }
        return dtData;
    }
    protected void WebHierarchicalDataGrid1_RowIslandsPopulating(object sender, ContainerRowCancelEventArgs e)
    {
        e.Cancel = true;
    
        DataView dv = dsSource.Tables[1].DefaultView;
        dv.RowFilter = "Column_11=" + e.Row.DataKey[0];
        ContainerGrid child = new ContainerGrid();
        e.Row.RowIslands.Add(child);
        child.ShowHeader = false;
        child.DataSource = dv;
        child.DataBind();




    }
    protected void WebHierarchicalDataGrid1_PreRender(object sender, EventArgs e)
    {
        
    }
    protected void WebHierarchicalDataGrid1_InitializeRow(object sender, RowEventArgs e)
    {
       
        ContainerGridRecord gridRecord = (ContainerGridRecord)e.Row;

        var owner = gridRecord.Owner;

        if (owner.ControlMain.Band!=null && owner.ControlMain.Band.Key == "Level0")
        {
            gridRecord.IsEmptyParent = true;
        }
        else
        {
            gridRecord.IsEmptyParent = false;
        }
    }
    protected void WebHierarchicalDataGrid1_InitializeBand(object sender, BandEventArgs e)
    {

    }
  
}